﻿using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;
using MacGruber;
using octopussy;
using MVR.FileManagementSecure;
using Random = System.Random;
using Random2 = UnityEngine.Random;

namespace SPQR
{
    public class Ticklish : MVRScript
    {
		
		/* cycle */
		public float timer;
		public float forceTimer;
		public float flip;
		public Vector3 targetForce;
		public Vector3 targetTorque;
		public Vector3 currentForce;
		public Vector3 currentTorque;
		public float delay;

		public Rigidbody RB;
		protected virtual Vector3 AxisToVector(ForceProducerV2.AxisName axis) {
			Vector3 result;
			if (RB != null) {
				switch (axis) {
					case ForceProducerV2.AxisName.X:
						result = RB.transform.right;
						break;
					case ForceProducerV2.AxisName.NegX:
						result = -RB.transform.right;
						break;
					case ForceProducerV2.AxisName.Y:
						result = RB.transform.up;
						break;
					case ForceProducerV2.AxisName.NegY:
						result = -RB.transform.up;
						break;
					case ForceProducerV2.AxisName.Z:
						result = RB.transform.forward;
						break;
					case ForceProducerV2.AxisName.NegZ:
						result = -RB.transform.forward;
						break;
					default:
						result = Vector3.zero;
						break;
				}
			} else {
				result = Vector3.zero;
			}
			return (result);
		}

		protected void SetTargets(float percent) {
			targetForce = AxisToVector(_forceAxis) * percent * forceFactorJSON.val;
			targetTorque = AxisToVector(_torqueAxis) * percent * torqueFactorJSON.val;
		}

		public void SyncReceiver(string receiver) {
			if (receiver != null) {
				ForceReceiver fr;
				if (receiverNameToForceReceiver.TryGetValue(receiver, out fr)) {
					RB = fr.GetComponent<Rigidbody>();
				} else {
					RB = null;
				}
			} else {
				RB = null;
			}
		}
		public JSONStorableStringChooser receiverChoiceJSON;

		public ForceProducerV2.AxisName _forceAxis = ForceProducerV2.AxisName.Z;
		public void SyncForceAxis(string axisName) {
			try {
				ForceProducerV2.AxisName an = (ForceProducerV2.AxisName)System.Enum.Parse(typeof(ForceProducerV2.AxisName), axisName);
				_forceAxis = an;
			}
			catch (System.ArgumentException) {
				Debug.LogError("Attempt to set axis to " + axisName + " which is not a valid axis name");
			}
		}
		public JSONStorableStringChooser forceAxisJSON;


		public ForceProducerV2.AxisName _torqueAxis = ForceProducerV2.AxisName.X;
		public void SyncTorqueAxis(string axisName) {
			try {
				ForceProducerV2.AxisName an = (ForceProducerV2.AxisName)System.Enum.Parse(typeof(ForceProducerV2.AxisName), axisName);
				_torqueAxis = an;
			}
			catch (System.ArgumentException) {
				Debug.LogError("Attempt to set axis to " + axisName + " which is not a valid axis name");
			}
		}
		public JSONStorableStringChooser torqueAxisJSON;

		public JSONStorableFloat periodJSON;
		public JSONStorableFloat periodRatioJSON;
		public JSONStorableFloat forceDurationJSON;
		public JSONStorableFloat forceFactorJSON;
		public JSONStorableFloat forceQuicknessJSON;
		public JSONStorableFloat torqueFactorJSON;
		public JSONStorableFloat torqueQuicknessJSON;
		public JSONStorableBool applyForceOnReturnJSON;

		public List<string> receiverChoices;
		public Dictionary<string, ForceReceiver> receiverNameToForceReceiver;
		
		/* other */

        private bool gameIsVR;
		
        GameObject playerHands;
        float collisionThreshold = 0.00f;

        protected JSONStorableString myString;


        Dictionary<string, float> clicks = new Dictionary<string, float>();
        private float downClickTime;
        private float ClickDeltaTime = 1f;

        public override void Init()
        {
            Utils.OnInitUI(CreateUIElement);
            gameIsVR = XRSettings.isDeviceActive && !string.IsNullOrEmpty(XRSettings.loadedDeviceName);
			
			
			JSONStorableString logo = new JSONStorableString("logostring", "\n<size=40><b>Ticklish</b></size>");
            UIDynamicTextField logotext = CreateTextField(logo);
            logotext.UItext.supportRichText = true;
            logotext.backgroundColor = new Color(0f, 0f, 0f, 0f);
            logotext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            logotext.height = 100f;
            logotext.UItext.alignment = TextAnchor.UpperLeft;


            JSONStorableString logor = new JSONStorableString("logospace", "\n<size=30><b>v1.0	</b></size>");
            UIDynamicTextField logortext = CreateTextField(logor, true);
            logortext.UItext.supportRichText = true;
            logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
            logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
            logortext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            logortext.height = 100f;
            logortext.UItext.alignment = TextAnchor.UpperRight;

            Utils.SetupSpacer(this, 50, false);
            Utils.SetupSpacer(this, 50, true);

            JSONStorableString jstring = new JSONStorableString("instructions1", "\n 1.Add the plugin to a Person Atom.\n 2. Start Tickling!");
            UIDynamicTextField dtext = CreateTextField(jstring, false);
            dtext.UItext.supportRichText = true;
            dtext.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
            dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext.height = 200f;

             
            JSONStorableString jstring2 = new JSONStorableString("instructions2", "\n On desktop you can right click on the person to tickle. Ticklish areas: face, chest, abdomen, breasts, thighs &shoulders");
            UIDynamicTextField dtext2 = CreateTextField(jstring2,true);
            dtext2.UItext.supportRichText = true;
            dtext2.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
            dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext2.height = 200f;

			bool showUI = false;

            receiverChoices = new List<string>();
				receiverNameToForceReceiver = new Dictionary<string, ForceReceiver>();
				receiverChoices.Add("none");
				foreach (ForceReceiver fr in containingAtom.forceReceivers) {
					receiverChoices.Add(fr.name);
					receiverNameToForceReceiver.Add(fr.name, fr);
				}
				receiverChoiceJSON = new JSONStorableStringChooser("receiver", receiverChoices, null, "Receiver", SyncReceiver);
				receiverChoiceJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterStringChooser(receiverChoiceJSON);
				if(showUI){
					UIDynamicPopup dp = CreateScrollablePopup(receiverChoiceJSON);
					dp.popupPanelHeight = 500f;
					dp.popup.alwaysOpen = false;
				}

				string[] axisChoices = System.Enum.GetNames(typeof(ForceProducerV2.AxisName));
				List<string> axisChoicesList = new List<string>(axisChoices);

				forceAxisJSON = new JSONStorableStringChooser("forceAxis", axisChoicesList, _forceAxis.ToString(), "Force Axis", SyncForceAxis);
				forceAxisJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterStringChooser(forceAxisJSON);
				if(showUI){
					CreatePopup(forceAxisJSON,true);
				}

				torqueAxisJSON = new JSONStorableStringChooser("torqueAxis", axisChoicesList, _torqueAxis.ToString(), "Torque Axis", SyncTorqueAxis);
				torqueAxisJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterStringChooser(torqueAxisJSON);
				if(showUI){
					CreatePopup(torqueAxisJSON,true);
				}

				periodJSON = new JSONStorableFloat("period", 0.2f, 0f, 10f, false);
				periodJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(periodJSON);
				if(showUI){
					CreateSlider(periodJSON, true);
				}

				periodRatioJSON = new JSONStorableFloat("periodRatio", 0.5f, 0f, 1f, true);
				periodRatioJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(periodRatioJSON);
				if(showUI){
					CreateSlider(periodRatioJSON, true);
				}

				forceDurationJSON = new JSONStorableFloat("forceDuration", 1f, 0f, 1f, true);
				forceDurationJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(forceDurationJSON);
				if(showUI){
					CreateSlider(forceDurationJSON, true);
				}

				forceFactorJSON = new JSONStorableFloat("forceFactor", 20f, 0f, 1000f, false, true);
				forceFactorJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(forceFactorJSON);
				if(showUI){
					CreateSlider(forceFactorJSON, true);
				}

				forceQuicknessJSON = new JSONStorableFloat("forceQuickness", 10f, 0f, 50f, false, true);
				forceQuicknessJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(forceQuicknessJSON);
				if(showUI){
					CreateSlider(forceQuicknessJSON, true);
				}
				torqueFactorJSON = new JSONStorableFloat("torqueFactor", 5f, 0f, 100f, false, true);
				torqueFactorJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(torqueFactorJSON);
				if(showUI){
					CreateSlider(torqueFactorJSON, true);
				}

				torqueQuicknessJSON = new JSONStorableFloat("torqueQuickness", 10f, 0f, 50f, false, true);
				torqueQuicknessJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterFloat(torqueQuicknessJSON);
				if(showUI){
					CreateSlider(torqueQuicknessJSON, true);
				}

				applyForceOnReturnJSON = new JSONStorableBool("applyForceOnReturn", true);
				applyForceOnReturnJSON.storeType = JSONStorableParam.StoreType.Full;
				RegisterBool(applyForceOnReturnJSON);
				if(showUI){
					CreateToggle(applyForceOnReturnJSON, true);
				}


			




            SimpleTriggerHandler.LoadAssets();





            // myString = new JSONStorableString("myString", "", UpdateMyString);
            // RegisterString(myString);
            // UIDynamicLabelInput myStringInput = Utils.SetupTextInput(this, "My String", myString, false);


            


            // Utils.SetupButton(this, "RaeUI Init", RaeUIInit, false);
            // Utils.SetupButton(this, "DirtyModInit", DirtyModInit, false);

            UIUpdate();
            RefreshColliders();
        }

        private void UIUpdate()
        {
        }


        void Start()
        {
			timer = 0f;
			forceTimer = 0f;
			flip = 1f;
        }

        void Update()
        {
            try
            {
			AEClick();
				
				
			timer -= Time.deltaTime;
			forceTimer -= Time.deltaTime;
			if (timer < 0.0f) {
				if ((flip > 0f && periodRatioJSON.val != 1f) || periodRatioJSON.val == 0f) {
					if (applyForceOnReturnJSON.val) {
						flip = -1f;
					} else {
						flip = 0f;
					}
					timer = periodJSON.val * (1f - periodRatioJSON.val);
					forceTimer = forceDurationJSON.val * periodJSON.val;
				} else {
					flip = 1f;
					timer = periodJSON.val * periodRatioJSON.val;
					forceTimer = forceDurationJSON.val * periodJSON.val;
				}
				SetTargets(flip);
			} else if (forceTimer < 0.0f) {
				SetTargets(0f);
			}


            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private void TestTrigger()
        {
            // var jc = this.GetJSON(true, true, false);
            // SuperController.LogMessage("current : " + jc.ToString().Replace("\"", "\\\""));

            //var XA = SuperController.singleton.GetAtomByUid("_RAEUI/startbutton");


            // !!!!nameof(collider.attachedRigidbody)


            // var xacollider = XA.rigidbodies.First() ;

            // if(xacollider!= null){
            //     SuperController.LogMessage("com found");
            //      SuperController.LogMessage(xacollider.name+" - "+xacollider.GetInstanceID());
            // } else {
            //     SuperController.LogMessage("not found");
            // }


        }
   

        void FixedUpdate()
        {
            try
            {
				// apply forces here
				float timeFactor = Time.fixedDeltaTime;
				currentForce = Vector3.Lerp(currentForce, targetForce, timeFactor * forceQuicknessJSON.val);
				currentTorque = Vector3.Lerp(currentTorque, targetTorque, timeFactor * torqueQuicknessJSON.val);
				if (RB && (!SuperController.singleton || !SuperController.singleton.freezeAnimation)) {
					RB.AddForce(currentForce, ForceMode.Force);
					RB.AddTorque(currentTorque, ForceMode.Force);
				}
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnDisable()
        {
            playerHands = GameObject.Find("Hands");
            if (playerHands)
            {

                playerHands
                    .GetComponentsInChildren<Rigidbody>()
                    .Where(f => f.name == "R_Finger_Middle_C"
                             || f.name == "L_Finger_Middle_C"
                             //  || f.name == "R_Finger_Index_C"
                             //  || f.name == "L_Finger_Index_C"
                             //  || f.name == "L_Finger_Thumb_C"
                             //  || f.name == "R_Finger_Thumb_C"
                             //  || f.name == "L_Finger_Thumb_A"
                             //  || f.name == "R_Finger_Thumb_A"
                             //  || f.name == "L_Finger_Ring_C"
                             //  || f.name == "R_Finger_Pinky_C"
                             //  || f.name == "L_Finger_Pinky_C"
                             //  || f.name == "R_Finger_Ring_C"
                             //  || f.name == "HandPhysical"
                             ).ToList().ForEach(f =>
                             {
                                 //SuperController.LogMessage("Disabled");
                                 f.gameObject.AddComponent<TriggerCollide>().OnCollide -= ObserveSpankTrigger;
                             });
            }
        }

        void OnDestroy()
        {
            Utils.OnDestroyUI();
            playerHands = GameObject.Find("Hands");
            if (playerHands)
            {

                playerHands
                    .GetComponentsInChildren<Rigidbody>()
                    .Where(f => f.name == "R_Finger_Middle_C"
                             || f.name == "L_Finger_Middle_C"
                             //  || f.name == "R_Finger_Index_C"
                             //  || f.name == "L_Finger_Index_C"
                             //  || f.name == "L_Finger_Thumb_C"
                             //  || f.name == "R_Finger_Thumb_C"
                             //  || f.name == "L_Finger_Thumb_A"
                             //  || f.name == "R_Finger_Thumb_A"
                             //  || f.name == "L_Finger_Ring_C"
                             //  || f.name == "R_Finger_Pinky_C"
                             //  || f.name == "L_Finger_Pinky_C"
                             //  || f.name == "R_Finger_Ring_C"
                             //  || f.name == "HandPhysical"
                             ).ToList().ForEach(f =>
                             {
                                 f.gameObject.AddComponent<TriggerCollide>().OnCollide -= ObserveSpankTrigger;
                             });
            }
        }



        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
            if (includePhysical || forceStore)
            {
                needsStore = true;
            }
            return jc;
        }

        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);


        }



        public void AEClick()
        {
            if (Input.GetKey(KeyCode.LeftShift) || Input.GetKey(KeyCode.LeftControl) || Input.GetKey(KeyCode.LeftAlt)) return;
            Plane plane = new Plane(Vector3.up, 0);
            if (Input.GetMouseButtonDown(1))
            {
                downClickTime = Time.time;
            }
            if (Input.GetMouseButtonUp(1))
            {
                if (Time.time - downClickTime <= ClickDeltaTime)
                {

                    // SuperController.LogMessage("click ");
                    float distance;
                    RaycastHit raycastHit = new RaycastHit();
                    bool found = false;
                    Vector3 worldPosition;
                    Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
                    if (plane.Raycast(ray, out distance) || true)
                    {

                        // SuperController.LogMessage("click2");
                        worldPosition = ray.GetPoint(distance);


                        RaycastHit[] hits = Physics.RaycastAll(ray);
                        if (hits.Length > 0)
                        {
                            //SuperController.LogMessage("HITS COUNT = " + hits.Length);
                            foreach (RaycastHit hit in hits)
                            {
                                if (hit.collider.name == "Plane") continue;
                                if (hit.collider.name == "Floor") continue;
                                if (hit.collider.name == "HardCollider") continue;
                                if (hit.collider.name == "_ColliderHair") continue;
                                if (hit.collider.name.Contains("HeadHair")) continue;
                                if (hit.collider.name.Contains("link") || hit.collider.name.Contains("Link")) continue;
                                if (hit.collider.name.Contains("control") || hit.collider.name.Contains("Control")) continue;
                               // SuperController.LogMessage("HITc: " + hit.collider);
                                if (!found)
                                {
                                    raycastHit = hit;
                                    found = true;
                                    break;
                                }
                            }
                        }
                        else
                        {
                            // SuperController.LogMessage("NOHITS: ");
                        }

                        if (found)
                        {
                            CurrentClickedGameObject(worldPosition, ray, raycastHit.transform.gameObject, raycastHit.collider);
                        }


                        // if (Physics.Raycast(ray, out raycastHit, 100f))
                        // {
                        //     if (raycastHit.transform != null)
                        //     {
                        //         CurrentClickedGameObject(worldPosition, ray, raycastHit.transform.gameObject, raycastHit.collider);
                        //     }
                        // }
                    }
                }

            }
        }
        public void RefreshColliders()
        {
            playerHands = GameObject.Find("Hands");
            if (playerHands)
            {// only the middle finger is the actual collider

                bool handLeftDone = false;



                playerHands
                    .GetComponentsInChildren<Rigidbody>()
                    .Where(f => f.name == "R_Finger_Middle_C"
                             || f.name == "L_Finger_Middle_C"
                             //  || f.name == "R_Finger_Index_C"
                             //  || f.name == "L_Finger_Index_C"
                             //  || f.name == "L_Finger_Thumb_C"
                             //  || f.name == "R_Finger_Thumb_C"
                             //  || f.name == "L_Finger_Thumb_A"
                             //  || f.name == "R_Finger_Thumb_A"
                             //  || f.name == "L_Finger_Ring_C"
                             //  || f.name == "R_Finger_Ring_C"
                             //  || f.name == "L_Finger_Pinky_C"
                             //  || f.name == "R_Finger_Pinky_C"

                             ).ToList().ForEach(f =>
                             {
                                 f.gameObject.AddComponent<TriggerCollide>().OnCollide += ObserveSpankTrigger;
                             });
            }

        }



        void ObserveSpankTriggerLeft(object sender, TriggerEventArgs e)
        {
            // SuperController.LogMessage("ObserveSpankTriggerLeft "+ sender.ToString());
            ObserveSpankTriggerCallback(sender, e, true);
        }
        void ObserveSpankTrigger(object sender, TriggerEventArgs e)
        {
            // SuperController.LogMessage("ObserveSpankTrigger "+ sender.ToString());
            ObserveSpankTriggerCallback(sender, e, false);
        }

        void ObserveSpankTriggerCallback(object sender, TriggerEventArgs e, bool forceLeft)
        {

            bool isLeft = false;
            if (sender.ToString() == "L_Finger_Middle_C (octopussy.TriggerCollide)") isLeft = true;
            // if (sender.ToString() == "L_Finger_Index_C (octopussy.TriggerCollide)")  isLeft = true;
            // if (sender.ToString() == "L_Finger_Thumb_C (octopussy.TriggerCollide)")  isLeft = true;
            // if (sender.ToString() == "L_Finger_Thumb_A (octopussy.TriggerCollide)")  isLeft = true;
            // if (sender.ToString() == "L_Finger_Ring_C (octopussy.TriggerCollide)")  isLeft = true;
            // if (sender.ToString() == "L_Finger_Pinky_C (octopussy.TriggerCollide)")  isLeft = true;
            if (forceLeft) isLeft = true;

            // SuperController.LogMessage("!!!!!Receiving event " + e.collider.name);




            Atom parent = null;
            foreach (var component in e.collider.gameObject.GetComponentsInParent<Component>())
            {

                var atom = component as Atom;
                if (atom != null)
                {
                    parent = atom;
                    break;
                }
            }
            if (parent == null || parent.name != containingAtom.name) return;


            //SuperController.LogMessage("xx " + e.collision.gameObject.name);

            var found = "";
            var components = e.collider.transform.parent.GetComponents<Component>();

            var RB = e.collider.attachedRigidbody;

            foreach (var xatom in SuperController.singleton.GetAtoms())
            {
                var RB2 = xatom.rigidbodies.First();
                if (RB == RB2)
                {
                    found = xatom.name;
                    break;
                }

            }



            if (e.evtType == octopussy.EventType.HIT)
            {
                float level = e.collision.relativeVelocity.magnitude / 3.0f;
                if (level > collisionThreshold)
                {
                    if (level > 3) level = 3;

                    //SuperController.LogMessage("collide at high level: " + level + ", threshold: " + collisionThreshold.val);
                    if (e.insideTrigger)
                    { }
                    else
                    {
                        var xname = found.Length > 0 ? found : parent.name;
                        var xcollider = e.collider.name;
                        RaeClickTouch(xname, xcollider);

                        //SuperController.LogMessage("!!!!!Receiving event " + parent.name + " of " + found + " of " + e.collider.name);
                        // SuperController.LogMessage("Collide with other object");

                    }
                }
                else
                { }
            }
            else
            { }
        }


        //////////////////////////////////////////////

		void prepareRandomTickle(){
			delay = (float)Random2.Range(0f,1.5f);
			periodJSON.val = (float)Random2.Range(0.1f,0.3f);
			forceFactorJSON.val = (float)Random2.Range(5f,40f);
			torqueFactorJSON.val = (float)Random2.Range(5f,10f);
			
			forceAxisJSON.val = RandomFromString(new string[] { "X", "Y", "Z"});
			torqueAxisJSON.val = RandomFromString(new string[] { "X", "Y", "Z"});
			
			torqueQuicknessJSON.val = (float)Random2.Range(5f,20f);
			forceQuicknessJSON.val = (float)Random2.Range(5f,20f);
			
		}
		
		void prepareVerySoftTickle(){
			periodJSON.val = (float)Random2.Range(0.3f,0.7f);
			forceFactorJSON.val = (float)Random2.Range(0.1f,1f);
			torqueFactorJSON.val = (float)Random2.Range(0.1f,1f);
			delay = (float)Random2.Range(0f,0.5f);
		}
		
		void prepareSoftTickle(){
			periodJSON.val = (float)Random2.Range(0.25f,0.7f);
			forceFactorJSON.val = (float)Random2.Range(1f,10f);
			torqueFactorJSON.val = (float)Random2.Range(1f,10f);
			delay = (float)Random2.Range(0f,0.5f);
		}
		string RandomFromString(string[] elements){
			Random rnd = new Random();
			int index = rnd.Next(elements.Length);
			return elements[index];
		}
		


		void RaeClickTouch(string name, string collider){
			
			//SuperController.LogMessage("Detected touch: "+name+" - "+collider);
			prepareRandomTickle();
			if(collider.Contains("CollidersHead") || collider.Contains("CollidersFace")){
				//SuperController.LogMessage("HEAD!");	
				receiverChoiceJSON.val = RandomFromString(new string[] { "neck", "head"});
				prepareSoftTickle();
			} else if(collider.Contains("Colliderschest")){
				//SuperController.LogMessage("CHEST!");	
				receiverChoiceJSON.val = "chest";
			} else if(collider.Contains("Collidersabdomen")){
				//SuperController.LogMessage("ABDOMEN!");	
				receiverChoiceJSON.val = RandomFromString(new string[] { "abdomen", "abdomen2"});
			}  else if(collider.Contains("ColliderslThigh")){
				//SuperController.LogMessage("lThigh!");	
				receiverChoiceJSON.val = "lThigh";
			} else if(collider.Contains("CollidersrThigh")){
				//SuperController.LogMessage("rThigh!");	
				receiverChoiceJSON.val = "rThigh";
			} 
			else if(collider.Contains("MeshJointleft") || collider.Contains("lPectoral") || collider.Contains("leftAreola")){
				//SuperController.LogMessage("lbreast!");	
				receiverChoiceJSON.val = "lPectoral";
				prepareVerySoftTickle();
			} 
			else if(collider.Contains("MeshJointright") || collider.Contains("rPectoral") || collider.Contains("rightAreola")){
				//SuperController.LogMessage("rbreast!");	
				receiverChoiceJSON.val = "rPectoral";
				prepareVerySoftTickle();
			} 
			else if(collider.Contains("lShldr") ){
				//SuperController.LogMessage("lShldr!");	
				receiverChoiceJSON.val = "lShldr";
			} 
			else if(collider.Contains("rShldr") ){
				//SuperController.LogMessage("rShldr!");	
				receiverChoiceJSON.val = "rShldr";
			} 
			else if(collider.Contains("hip") || collider.Contains("pelvis")){
				forceFactorJSON.val = (float)Random2.Range(15f,50f);
				torqueFactorJSON.val = (float)Random2.Range(15f,45f);
				//SuperController.LogMessage("hip!");	
				receiverChoiceJSON.val = RandomFromString(new string[] { "hip", "pelvis"});
			} else {
				//SuperController.LogMessage("none: "+collider);
				StartCoroutine(CoroutineStopTickle(0.01f));
				return;
			}

			
			
			StartCoroutine(CoroutineStopTickle(delay));
			
		}
		
		IEnumerator CoroutineStopTickle(float fadeDuration)
        {

				
            float initialVal = forceFactorJSON.val;
            float targetVal = 0f;
			
			float initialVal2 = torqueFactorJSON.val;
            float targetVal2 = 0f;

            float elapsedTime = 0f;
            bool done = false;
            while (elapsedTime < fadeDuration)
            {
                elapsedTime += Time.deltaTime;

				if (!done && elapsedTime >= fadeDuration ){
					done = true;
					
				}
				forceFactorJSON.val = Mathf.Lerp( initialVal, targetVal, elapsedTime / fadeDuration);
				torqueFactorJSON.val = Mathf.Lerp( initialVal2, targetVal2, elapsedTime / fadeDuration);

                yield return null;
            }
        }


        void UpdateMyString(string name)
        {
        }


        public void CurrentClickedGameObject(Vector3 click, Ray ray, GameObject gameObject, Collider collider)
        {


            var found = "";
            // foreach (var component in gameObject.GetComponentsInParent<Component>())
            // {

            //     var fc = component as FreeControllerV3;
            //     if (fc != null)
            //     {
            //         foreach (var xatom in SuperController.singleton.GetAtoms())
            //         {
            //             if (xatom.mainController == fc)
            //             {
            //                 found = xatom.name;
            //             }
            //         }

            //     }
            // }

            var RB = collider.attachedRigidbody;

            foreach (var xatom in SuperController.singleton.GetAtoms())
            {
                var RB2 = xatom.rigidbodies.First();
                if (RB == RB2)
                {
                    found = xatom.name;
                    break;
                }

            }

            // SuperController.LogMessage("found: " + found);
            foreach (var component in gameObject.GetComponentsInParent<Component>())
            {


                //SuperController.LogMessage("c: "+component.GetType());
                var atom = component as Atom;
                if (atom != null)
                {
                    var xname = found.Length > 0 ? found : atom.name;
                    if (atom.name != containingAtom.name) return;
                    var xcollider = collider.name;
                    RaeClickTouch(xname, xcollider);
                    break;
                }

            }

        }


        


    }



}
